import Vue from 'vue'

import icon from '../packages/icon/index'

import Button from '../packages/button/src/button'

import ButtonGroup from '../packages/button/src/buttonGroup'

Vue.component('w-icon', icon)
Vue.component('w-button', Button)
Vue.component('w-button-group', ButtonGroup)

new Vue({
  el: '#app',
  data () {
    return {
      loading1: false
    }
  }
})

// 单元测试
import chai from 'chai'
const except = chai.expect

{
  const Constructor = Vue.extend(Button)

  const button = new Constructor({
    propsData: {
      icon: 'download',
    },
  })

  button.$mount()

  let useElement = button.$el.querySelector('use')
  let href = useElement.getAttribute('xlink:href')

  except(href).to.eq('#wei-download')

  button.$el.remove()
  button.$destroy()
}

{
  const Constructor = Vue.extend(Button)

  const vm = new Constructor({
    propsData: {
      icon: 'download',
      loading: 'true'
    },
  })

  vm.$mount()

  let useElement = vm.$el.querySelector('use')
  let href = useElement.getAttribute('xlink:href')

  except(href).to.eq('#wei-loading')

  vm.$el.remove()
  vm.$destroy()
}

{
  const Constructor = Vue.extend(Button)

  const vm = new Constructor({
    propsData: {
      icon: 'download',
      iconPosition: 'right'
    },
  })

  vm.$mount('#text')

  let stvElement = vm.$el.querySelector('svg')
  let href = window.getComputedStyle(stvElement).order

  except(href).to.eq("2")

  vm.$el.remove()
  vm.$destroy()
}

// 点击事件
{
  const Constructor = Vue.extend(Button)
  const vm = new Constructor({
    propsData: {
      icon: 'download'
    },
  })

  let div = document.createElement(div)

  document.body.appendChild(div)

  vm.$mount()
 
  vm.$on('click', function() {
    except(1).to.eq(1)
  })
 
  vm.$el.click()

  vm.$destroy()

}